// Copyright (C) 1996 DIMACS Center, Rutgers, The State University of New Jersey
// Author(s): Patricia K. Fasel (Los Alamos Nat. Lab.), Jonathan Berry
// This software is copyrighted by the DIMACS Center at Rutgers, The State
// University of New Jersey.  IT IS PROVIDED AS IS, AND THE AUTHORS, DIMACS, AND
// RUTGERS, THE STATE UNIVERSITY OF NEW JERSEY  DISCLAIM
// ALL LIABILITY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
// DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
// DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
// THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
// IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
// NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
// MODIFICATIONS.
// The authors hereby grant permission to use, copy, modify, distribute,
// and license this software and its documentation for any purpose, provided
// that existing copyright notices are retained in all copies and that this
// notice is included verbatim in any distributions. No written agreement,
// license, or royalty fee is required for any of the authorized uses.
// Modifications to this software may be copyrighted by their authors
// and need not follow the licensing terms described here, provided that
// the new terms are clearly indicated on the first page of each file where
// they apply.
// Last File Update: 30-May-1997
// 
#define DEFINE_ElementOps_TEMPLATE
#define DEFINE_Attribute_TEMPLATE
#define DEFINE_List_TEMPLATE

#include <LINK/basic/ElementOps.h>
#include <LINK/basic/List.h>
#include <LINK/graph/Attribute.h>
#include <LINK/algorithm/AnimationData.h>

#undef DEFINE_List_TEMPLATE
#undef DEFINE_ElementOps_TEMPLATE
#undef DEFINE_Attribute_TEMPLATE

typedef AnimationData* AnimationDataPtr;
int ElementOps<AnimationData*>::compareItems(const AnimationDataPtr& a1,
					     const AnimationDataPtr& a2) 
{
	if (*a1 < *a2)
		return -1;
	else   if (*a1 == *a2) 
		return 0;
	else
		return 1;
}

#include <LINK/basic/DList.h>
#include <LINK/basic/Array.h>
#include <LINK/graph/Buckets.h>
#include <LINK/algorithm/Partitioning.h>
#include <LINK/graph/Graph.h>

ostream& AttributeElementOps<VertexInfoPtr>::displayItem(ostream& os,
                                                const VertexInfoPtr& e) const;
ostream& AttributeElementOps<CutStatePtr>::displayItem(ostream& os,
                                                const CutStatePtr& e) const;

typedef VertexInfo* VertexInfoPtr;

typedef Attribute<CutStatePtr> _Attribute_CutStatePtr;
typedef Attribute<VertexInfoPtr> _Attribute_VertexInfoPtr;

template class ElementOps<_Attribute_CutStatePtr>;
template class Attribute<CutStatePtr>;
template class AttributeElementOps<CutStatePtr>;

template int newAttribute(Graph*, String, CutStatePtr);
template int getAttribute(GraphObject*, String, CutStatePtr&);
template int setAttribute(GraphObject*, String, CutStatePtr);


ostream& AttributeElementOps<CutStatePtr>::displayItem(ostream& os,
                                                const CutStatePtr& e) const
{
	if (e) {
        	os << *e;
	} else
		os << 0;
        return os;
}

template class ElementOps<_Attribute_VertexInfoPtr>;
template class Attribute<VertexInfoPtr>;
template class AttributeElementOps<VertexInfoPtr>;

template int newAttribute(Graph*, String, VertexInfoPtr);
template int getAttribute(GraphObject*, String, VertexInfoPtr&);
template int setAttribute(GraphObject*, String, VertexInfoPtr);


ostream& AttributeElementOps<VertexInfoPtr>::displayItem(ostream& os,
                                                const VertexInfoPtr& e) const
{
	if (e) {
        	os << *e;
	} else
		os << 0;
        return os;
}
